clear VOCopts

VOCopts.dataset = 'OSUT';

% get devkit directory with forward slashes
devkitroot=strrep(fileparts(fileparts(mfilename('fullpath'))),'\','/');

% change this path to point to your copy of the PASCAL VOC data
VOCopts.datadir=[devkitroot '/'];

% change this path to a writable directory for your results
VOCopts.resdir=[devkitroot '/results/' expname '/'];

% change this path to a writable local directory for the example code
VOCopts.localdir=[devkitroot '/local/' expname '/'];

% initialize the training set
% VOCopts.testset='val'; % use validation data for development test set
% VOCopts.testset='test'; % use test set for final challenge
VOCopts.testset='train';
% initialize main challenge paths

%VOCopts.datadir=...VOCdevkit/; VOCopts.dataset=OSUT
VOCopts.annopath=[VOCopts.datadir VOCopts.dataset '/Annotations/%s.txt'];
VOCopts.imgpath=[VOCopts.datadir VOCopts.dataset '/Images/%s'];
VOCopts.imgsetpath=[VOCopts.datadir VOCopts.dataset '/ImageSets/%s.txt'];
VOCopts.clsimgsetpath=[VOCopts.datadir VOCopts.dataset '/ImageSets/%s_%s.txt'];

VOCopts.clsrespath=[VOCopts.resdir '%s_cls_' VOCopts.testset '_%s.txt'];
VOCopts.detrespath=[VOCopts.resdir '%s_det_' VOCopts.testset '_%s.txt'];

% VOC2008 classes

VOCopts.classes={'PASosuthperson'};    

VOCopts.nclasses=length(VOCopts.classes);	

VOCopts.minoverlap=0.5;

% annotation cache for evaluation

VOCopts.annocachepath=[VOCopts.localdir '%s_anno.mat'];

% options for example implementations

VOCopts.exfdpath=[VOCopts.localdir '%s_fd.mat'];
