function [ResMap] = MCSwithDFTII(dContainer, bias, tContainer, dftsize)

tol = 0.001;
% DFT Computation of target image

[M, N, dimen] = size(tContainer.scaledfeat);
M1 = (dftsize(1) - M)/2; N1 = (dftsize(2) - N)/2;
ResMap = double(zeros(M, N));

m = size(dContainer.scaledfeat, 1);
n = size(dContainer.scaledfeat, 2);

start_m = m/2; last_m = M - start_m;
start_n = n/2; last_n = N - start_n;

Y = double(zeros(dftsize(1), dftsize(2)));
for d = 1 : dimen
    Y = Y + dContainer.DFT(:, :, d).*tContainer.DFT(:, :, d);
end
rho_fft = real(fftshift(ifft2(Y)));
rho_n = rho_fft(M1+1:M1+M,N1+1:N1+N);
% sqrt done later to decide tol
rho_d = areasumtable(sum((tContainer.scaledfeat).^2, 3), m, n); 

% elementise division guarding zeros
guardZeroDenom = zeros(M, N); % introduced so that I can ignore boundary
i_nonzero = find(rho_d > tol);
guardZeroDenom(i_nonzero) = (rho_n(i_nonzero)./sqrt(rho_d(i_nonzero))) + bias;

% ignore boundary
ResMap(start_m:last_m, start_n:last_n) = guardZeroDenom(start_m:last_m, start_n:last_n);


