function local_sum = areasumtable(A,m,n)

% Matlab Image Processing Toolbox
% We thank Eli Horn for providing this code, used with his permission,
% to speed up the calculation of local sums. The algorithm depends on
% precomputing running sums as described in "Fast Normalized
% Cross-Correlation", by J. P. Lewis, Industrial Light & Magic.

% Adapted from Matlab Image Processing toolbox

% if ((mod(m, 2) ~= 0) || (mod(n, 2) ~= 0))
%     error('Detector row and col must be even in number');
% end
    
B = padarray(A,[m n]);
s = cumsum(B,1);
c = s(1+m:end-1,:)-s(1:end-m-1,:);
s = cumsum(c,2);
local_sum_A = s(:,1+n:end-1)-s(:,1:end-n-1);
local_sum_B = circshift(local_sum_A, [-floor(m/2)+1 -floor(n/2)+1]);
local_sum = local_sum_B(1:size(A, 1), 1:size(A, 2));