function detector = call_solver_v3(y, data, VOCopts, param)

detector = struct('w', [], 'b', [], 'info', []);

features_sparse = sparse(double(data')); % row vector features must be in a sparse matrix
libsvmwrite(strcat(VOCopts.localdir, 'traindata.txt'), double(y), features_sparse);
[label_libsvm_format, data_libsvm_format] = libsvmread(strcat(VOCopts.localdir, 'traindata.txt'));

info = svmtrain(label_libsvm_format, data_libsvm_format, ['-s 0 -t 0 -c ' num2str(param)]);

detector.w = info.SVs' * info.sv_coef;
detector.b = -info.rho;
if info.Label(1) == -1
    detector.w = -detector.w;
    detector.b = -detector.b;
end
detector.info = info;
