function [dftcontainer] = channelwiseMultiScaleDFT2(FTensor, dftsize, scales, doCONJ)

dftcontainer(length(scales)) = struct('scaledfeat', [], 'DFT', []);

m = size(FTensor, 1);n = size(FTensor, 2);d = size(FTensor, 3);
m_scaled = round(m*scales);
m_scaled = mod(m_scaled, 2) + m_scaled;
n_scaled = round(n*scales);
n_scaled = mod(n_scaled, 2) + n_scaled;


for nsc = 1 : length(scales)
    m1 = (dftsize(1) - m_scaled(nsc))/2; 
    n1 = (dftsize(2) - n_scaled(nsc))/2;
    dftcontainer(nsc).scaledfeat = imresize(FTensor, [m_scaled(nsc) n_scaled(nsc)], 'bilinear');    
    dftcontainer(nsc).DFT = double(zeros(dftsize(1), dftsize(2), d));
    FZ_Q = padarray(dftcontainer(nsc).scaledfeat, [m1 n1 0]);    
    switch doCONJ
        case true
            for dim = 1 : d
                dftcontainer(nsc).DFT(:, :, dim) = conj(fft2(FZ_Q(:,:, dim)));
            end
        case false
            for dim = 1 : d
                dftcontainer(nsc).DFT(:, :, dim) = fft2(FZ_Q(:,:, dim));
            end
        otherwise
            error('Unrecognized input in channelwiseMultiScaleDFT');
    end    
end