function numadded = customneg(posImagewise, negdatafile, VOCopts)

conf = m3cs_conf();
W = conf.detector.w;
H = conf.detector.h;
upperlim_per_image = 2;
neg = []; numadded = 0;
fid = fopen(negdatafile, 'w');
verbose = false;

for n = 1:length(posImagewise);

    X = posImagewise(n).width;
    Y = posImagewise(n).height;
    im1 = double(zeros(Y, X));
    
    for npos = 1:posImagewise(n).numobj
        im1(posImagewise(n).object(npos).y1:posImagewise(n).object(npos).y2, ...
            posImagewise(n).object(npos).x1:posImagewise(n).object(npos).x2) = 1;
    end
    [~, flname, ~] = fileparts(posImagewise(n).im);
    load(strcat(VOCopts.localdir, flname, '_lsk_pca.mat'), 'lsk_pca');
    count_per_im = 0;
    while 1
        im2 = zeros(Y, X);
        negwin = round([1; 1] + [(Y-H) 0; 0 (X-W)]*rand(2, 1));
        im2(negwin(1):negwin(1)+H-1, negwin(2):negwin(2)+W-1) = 1;
        intrsctn = im1.*im2;
        ioveru = sum(intrsctn(:))/sum(im2(:));
        if ioveru < 0.001
            if count_per_im <= upperlim_per_image
                numadded = numadded + 1;
                neg(numadded).im = posImagewise(n).im;
                neg(numadded).x1 = negwin(2);
                neg(numadded).y1 = negwin(1);
                neg(numadded).x2 = negwin(2)+W-1;
                neg(numadded).y2 = negwin(1)+H-1;
                
                negLSK = lsk_pca(negwin(1):negwin(1)+H-1,negwin(2):negwin(2)+W-1,1:conf.ndLSK);
                featvec = negLSK(:); 
                
                datan = featvec/sqrt(featvec'*featvec);
                data2 = [negwin(2) negwin(1) negwin(2)+W-1 negwin(1)+H-1];
                fwrite(fid, -1, 'int32'); % label
                fwrite(fid, flname, 'char'); % 14 character file identifier
                fwrite(fid, data2, 'int32'); % 4 dim bbox
                fwrite(fid, datan, 'single'); % examples

                % add negative
                count_per_im = count_per_im + 1;
                clear negLSK featvec datan data2;
            else
                break;
            end
        end
    end
end
fclose(fid);
if verbose, fprintf('\n Total #neg: %d \n', numadded); end
