function N_POS = extractpos(pos, posfullfile, VOCopts)

verbose = false; 

conf = m3cs_conf(); W = conf.detector.w; H = conf.detector.h;
aspctRatio = W/H;
Whalf = round(W/2); Hhalf = round(H/2);

N_POS = 0;
fid = fopen(posfullfile, 'w');
for numpos = 1 : length(pos)
    [~,flname,~]=fileparts(pos(numpos).im);
    load(strcat(VOCopts.localdir, flname, '_lsk_pca.mat'), 'lsk_pca');
       
    padded_lsk_pca = padarray(lsk_pca, [Hhalf Whalf]);
    if verbose
    figure(1), imagesc(imread(pos(numpos).im)), colormap(gray), axis image, axis on;
    end
    for nobj = 1 : pos(numpos).numobj
        
        x1 = pos(numpos).object(nobj).x1;
        y1 = pos(numpos).object(nobj).y1;
        x2 = pos(numpos).object(nobj).x2;
        y2 = pos(numpos).object(nobj).y2;
     
        % compute bbox: accept the height, work out the width
        expWidth = round(aspctRatio*(y2 - y1 + 1));        
        x1 = round((x1+x2)/2 - expWidth/2);
        x2 = x1 + expWidth - 1;
        
        % extract here!
        if conf.usePrecomputedFeature
            posLSK = imresize(padded_lsk_pca(y1+Hhalf:y2+Hhalf,x1+Whalf:x2+Whalf,1:conf.ndLSK), [H W], 'bicubic'); 
            featvec = posLSK(:);                          
        else
            error('ExtractPOS: Not Yet Supported');
            % extract im bbox, resize to (x1,y1) x (x2, y2), extract LSK
            % tensor as posLSK
        end            
    
        datap = featvec/sqrt(featvec'*featvec);
        fwrite(fid, 1, 'int32'); % label
        fwrite(fid, flname, 'char'); % file identifier: 14 characters
        fwrite(fid, [x1 y1 x2 y2], 'int32'); % bbox
        fwrite(fid, datap, 'single'); % data: htxwdxndLSK dimensional
        N_POS = N_POS + 1;
        if verbose
            figure(1), rectangle('Position', [x1 y1 expWidth (y2-y1+1)], 'EdgeColor', 'r', 'LineWidth', 4);
            for q = 1 : 3
                figure(20), subplot(1, 3, q), imagesc(posLSK(:,:,q)), colormap(gray), axis image, axis on;
            end
            pause;
        end
        clear datap featvec posLSK;
    end
    
    clear lsk_pca padded_lsk_pca    
end
fclose(fid);
if verbose, fprintf('\n Total #pos: %d', N_POS); end

