function rect = nmsBBoxMS2(RM,szQ,T_n,s_ind,scales,searchmode)

[M, N] = size(RM);

height = szQ(1); width = szQ(2); 

bbox = zeros(ceil(M/height)* ceil(N/width), 5); % max possible #detections

cnt = 0;
    
largeneg = T_n - 1000.0; 

topscore = max(RM(:));

scaled_mn = [round(height*scales) round(width*scales)];
scaled_mn = mod(scaled_mn, 2) + scaled_mn;
while topscore > T_n

    [r_ind,c_ind] = find(RM==topscore);   
    
    if numel(r_ind) > 1
        r_ind = r_ind(1);
        c_ind = c_ind(1);
    end

    if searchmode ~= 0 
        scaled_window = scaled_mn(s_ind(r_ind,c_ind), :);
    else
        error('Single scale non-maximal suppression not supported here');
    end
      
%     r_b = max(1, r_ind - scaled_window(1)/2 + 1);
    r_b = max(1, r_ind - scaled_window(1)/2);
    r_e = min(M, r_b + scaled_window(1) - 1);
%     c_b = max(1, c_ind - scaled_window(2)/2 + 1);
     c_b = max(1, c_ind - scaled_window(2)/2);
    c_e = min(N, c_b + scaled_window(2) - 1);
     
    if cnt > 0
        ovmax=-inf;
        for j=1:cnt
            bbgt=bbox(j, 2:end);
            bi=[max(c_b,bbgt(1)) ; max(r_b,bbgt(2)) ; min(c_e,bbgt(3)) ; min(r_e,bbgt(4))];
            iw=bi(3)-bi(1)+1;
            ih=bi(4)-bi(2)+1;
            if iw>0 && ih>0
                % compute overlap as area of intersection / area of union
                ua=(c_e-c_b+1)*(r_e-r_b+1)+...
                    (bbgt(3)-bbgt(1)+1)*(bbgt(4)-bbgt(2)+1)-...
                    iw*ih;
                ov=iw*ih/ua;
                if ov>ovmax
                    ovmax=ov;
%                     jmax=j;
                end
            end
        end

        if ovmax < 0.5
            cnt = cnt + 1;
            bbox(cnt, :) = [topscore c_b r_b c_e r_e]; % multiple detection
            RM(r_b:r_e, c_b:c_e) = largeneg;
%             fprintf('\n multiple --- cnt %d: r_cnt=%d, c_cnt=%d, width=%d, height=%d, score=%f; scale %d', ...
%                 cnt, r_ind, c_ind, c_e-c_b, r_e-r_b, topscore, s_ind(r_ind,c_ind));
        else
            RM(r_b:r_e, c_b:c_e) = largeneg; % non maximum suppression            
        end  
    else
        cnt = cnt + 1;
        bbox(cnt, :) = [topscore c_b r_b c_e r_e]; % first detection
        RM(r_b:r_e, c_b:c_e) = largeneg; 
%         fprintf('\n First --- cnt %d: r_cnt=%d, c_cnt=%d, width=%d, height=%d, score=%f; scale %d', ...
%             cnt, r_ind, c_ind, c_e-c_b, r_e-r_b, topscore, s_ind(r_ind,c_ind));
    end   
    topscore = max(RM(:));    
end
rect = bbox(1:cnt, :);
end