function [pos] = pascal_data(cls, VOCopts, imgset)

% [pos, neg] = pascal_data(cls)
% Get training data from the PASCAL dataset.

% positive examples from train+val
ids = textread(sprintf(VOCopts.imgsetpath, imgset), '%s');
pos = [];
numpos = 0;

for i = 1:length(ids);
%     fprintf('%s: parsing positives: %d/%d\n', ids{i}, i, length(ids));
    rec = PASreadrecord(sprintf(VOCopts.annopath, ids{i}));
    clsinds = strmatch(cls, {rec.objects(:).class}, 'exact');
    % skip difficult examples
    diff = [rec.objects(clsinds).difficult];
    clsinds(diff) = [];
    
    [~, flnm, flext] = fileparts(rec.imgname); 
    flnm = strcat(flnm, flext); clear flext;
    
    for j = clsinds(:)'
        numpos = numpos+1;        
        pos(numpos).im = sprintf(VOCopts.imgpath, flnm);
        bbox = rec.objects(j).bbox;
        pos(numpos).x1 = bbox(1);
        pos(numpos).y1 = bbox(2);
        pos(numpos).x2 = bbox(3);
        pos(numpos).y2 = bbox(4);
        pos(numpos).height = rec.imgsize(2);
        pos(numpos).width = rec.imgsize(1);
        pos(numpos).channel = rec.imgsize(3);
%         pos(numpos).flip = false;
%         pos(numpos).trunc = rec.objects(j).truncated;
    end
end
% save([VOCopts.localdir 'posdata.mat'], 'pos');
end
