%% wrapper script
function precomputeFeatures(VOCopts, cls)
%% Loading dataset information for training set
fprintf('\n Training Set:');
conf = m3cs_conf();
try
    load([VOCopts.localdir 'OSUTHtrainset.mat'], 'gtpos');
    gt = gtpos; clear gtpos;
catch 
    fullgt = pascal_data(cls, VOCopts, 'train');
    gtpos = getposImagewise(fullgt);
    save([VOCopts.localdir 'OSUTHtrainset.mat'], 'gtpos');
    gt = gtpos; clear gtpos;
end

%% Feature Extraction for Training dataset
 
fprintf('\n Computing LSK Features: Training Set ... \n');
r0_computeFeatures(VOCopts, gt); % compute LSK descriptors

fprintf('\n Compute PCA Features: Training Set ... \n');
r1_computePCA(VOCopts, gt); % compute pca features


%% Loading dataset information for test set 
clear gt conf;
conf = m3cs_conf();
fprintf('\n Test Set:');
try
    load([VOCopts.localdir 'OSUTHtestset.mat'], 'gtpos');
    gt = gtpos; clear gtpos;
catch 
    fullgt = pascal_data(cls, VOCopts, 'test');
    gtpos = getposImagewise(fullgt);
    save([VOCopts.localdir 'OSUTHtestset.mat'], 'gtpos');
    gt = gtpos; clear gtpos;
end

fprintf('\n Computing LSK-PCA Features: Test Set ... \n');
r0_computeFeatures_testimages(VOCopts, gt); % compute LSK-PCA 

end
