function r0_computeFeatures_testimages(VOCopts, gt)

conf = m3cs_conf();
ndLSK = conf.ndLSK;

for numtest = 1 : length(gt)
    [~,flname,~]=fileparts(gt(numtest).im);
    thermim = imread(gt(numtest).im);
    normcar = double(thermim)/std(double(thermim(:)));
    LSK = computeLSK(normcar, lsk_conf);
    
    W = reshape(LSK,[size(LSK,1)*size(LSK,2),size(LSK,3)*size(LSK,4)])';
    premean = mean(W,2);
    N = size(W,2);
    meanMat = repmat(premean,[1 N]);
    centeredW = (W-meanMat);
    
    [evec,eval] = eig(centeredW * centeredW');
    [~, l] = sort(diag(eval),'descend');
    evec = evec(:,l);
    
    s1 = evec(1, :) < 0; sa = s1*(-1);
    sa = repmat(sa, [size(evec, 1) 1]);
    s2 = ~s1; sb = repmat(s2, [size(evec, 1) 1]);
    evec = evec.*sb + evec.*sa; % sb ??
    
    lsk_pca_row = centeredW' * evec(:, 1:ndLSK); % row vector per pixel
    lsk_pca = reshape(lsk_pca_row, [size(LSK,1) size(LSK,2) ndLSK]);
       
    save(strcat(VOCopts.localdir, flname, '_lsk_pca.mat'), 'normcar', 'LSK', 'lsk_pca', 'lsk_pca_row', 'W');
    if mod(numtest, 10) == 0
        fprintf('\n LSK-PCA computataion done for TEST: %d / %d', numtest, length(gt));
    end
    clear W premean evec eval flname lsk_pca lsk_pca_row
    
end
