function r1_computePCA(VOCopts, pos)
% PCA-LARK computation of all training images

conf = m3cs_conf();
ndLSK = conf.ndLSK;
W = conf.detector.w; H = conf.detector.h;
Whalf = round(W/2); Hhalf = round(H/2);

for numpos = 1 : length(pos)
    
    [~,flname,~]=fileparts(pos(numpos).im);
    load(strcat(VOCopts.localdir, flname, '_lsk.mat'), 'LSK');
    
    W = [reshape(LSK,[size(LSK,1)*size(LSK,2),size(LSK,3)*size(LSK,4)])'];
    premean = mean(W,2);
    N = size(W,2);
    meanMat = repmat(premean,[1 N]);
    centeredW = (W-meanMat);
    [evec,eval] = eig((W-meanMat)*(W-meanMat)');
    [~, l] = sort(diag(eval),'descend');
    evec = evec(:,l);

    s1 = evec(1, :) < 0; sa = s1*(-1);
    sa = repmat(sa, [size(evec, 1) 1]);
    s2 = ~s1; sb = repmat(s2, [size(evec, 1) 1]);
    evec = evec.*sb + evec.*sa; % sb??

    lsk_pca_row = centeredW' * evec(:, 1:ndLSK); % row vector per pixel
    lsk_pca = reshape(lsk_pca_row, [size(LSK,1) size(LSK,2) ndLSK]);
    padded_lsk_pca = padarray(lsk_pca, [Hhalf Whalf]);
    save(strcat(VOCopts.localdir, flname, '_lsk_pca.mat'), 'lsk_pca_row', 'W', 'lsk_pca', 'padded_lsk_pca');
    if mod(numpos, 10) == 0
        fprintf('\n \t PCA computataion done for POS: %d / %d', numpos, length(pos));
    end
    clear W premean evec eval flname lsk_pca lsk_pca_row
end