function n_neg = saveHardNegatives2(gt, VOCopts, w, b, hngdatafile)

verbose = false;

conf = m3cs_conf();
scales = conf.scales; % Scale parameters
dftsize = conf.dftsize; 
height = conf.detector.h; width = conf.detector.w; nchannel = conf.ndLSK;
detector = reshape(w, [height width nchannel]);

detectorContainer = channelwiseMultiScaleDFT2(detector, dftsize, 1, true);
alp = 0; s_ind = []; SC = []; searchmode = [];

fid = fopen(hngdatafile, 'w');
n_neg = 0;
for n = 1 : length(gt)
    [~, imfilenm, ~] = fileparts(gt(n).im);
    load(strcat(VOCopts.localdir, imfilenm, '_lsk_pca.mat'), 'lsk_pca');
    targetContainer = channelwiseMultiScaleDFT2(lsk_pca, dftsize, 1./scales, false);
    if gt(n).numobj
        gtbbox = [gt(n).object(:).x1; gt(n).object(:).y1; ...
            gt(n).object(:).x2; gt(n).object(:).y2];
    else
        gtbbox = [];
    end    
    
    for nsc = 1 : length(scales)
        RM = MCSwithDFTII(detectorContainer, b, targetContainer(nsc), dftsize);
        scoreBB = nmsBBoxSS(RM,[height width],alp,s_ind,SC,searchmode);
        targetscaled = targetContainer(nsc).scaledfeat;
        if verbose
        figure(1), clf(1), imagesc(imresize(imread(gt(n).im), [size(targetscaled, 1) size(targetscaled, 2)])), colormap(gray), axis image, axis on;
        end
        for nex = 1 : size(scoreBB, 1)
            [ovmax, ~] = bestIoverU(gtbbox, round(scales(nsc)*scoreBB(nex, 2:end)'));
            if ovmax < 0.35 
                tmp = targetscaled(scoreBB(nex, 3):scoreBB(nex, 5), scoreBB(nex, 2):scoreBB(nex, 4),:);
                if(size(tmp, 1) ~= height) || (size(tmp, 2) ~= width)
                    error('HARD MINING: extracted feature size mismatch');
                end
                if verbose
                    x = scoreBB(nex, 2); y = scoreBB(nex, 3);
                    wd = scoreBB(nex, 4) - scoreBB(nex, 2);
                    ht = scoreBB(nex, 5) - scoreBB(nex, 3);
                    figure(1), rectangle('Position', [x y wd ht], 'EdgeColor', 'r', 'LineWidth', 4);
                    for q = 1 : 3
                        figure(20), subplot(1, 3, q), imagesc(tmp(:,:,q)), colormap(gray), axis image, axis on;
                    end
                end
                feat = tmp(:)/sqrt(tmp(:)'*tmp(:));
                fwrite(fid, -1, 'int32');
                fwrite(fid, imfilenm, 'char');
                fwrite(fid, round(scales(nsc)*[scoreBB(nex, 2) scoreBB(nex, 3) scoreBB(nex, 4) scoreBB(nex, 5)]), 'int32');
                fwrite(fid, feat, 'single');
                n_neg = n_neg + 1;
                if verbose, pause; end
            end
           
        end
    end
    if 1, fprintf('\n HM Done: %d/%d-th Image', n, length(gt)); end
end
if verbose, fprintf('\n HM Summary: Total #hng %d', n_neg); end
fclose(fid); 