% function showExamples4mFile(posdatafile_1, n_pos1, 'OSU')
function showExamples4mFile(filename, N, VOCopts, showFeat)
conf = m3cs_conf();
height = conf.detector.h; width = conf.detector.w; nchannel = conf.ndLSK;
ndim = height*width*nchannel;

data = single(zeros(ndim));
fidpos = fopen(filename, 'r');

for n = 1 : N
    y = fread(fidpos, 1, 'int32');
    image_id = fread(fidpos, 14, '*char')';
    bbox = fread(fidpos, 4, 'int32');
    bbox(3) = bbox(3)-bbox(1) + 1;
    bbox(4) = bbox(4)-bbox(2) + 1;
    % read image and display bbox
    im = imread(sprintf(VOCopts.imgpath, [image_id '.bmp']));
    figure(1), imagesc(im), colormap(gray), axis image, axis on;
    rectangle('Position', bbox', 'EdgeColor', 'r', 'LineWidth', 4);
    fprintf('\n Image Id: %s; Hard ID: %d/%d; (width, height) = (%d, %d)', image_id, n, N, bbox(3:4));
    
    % read data
    data = fread(fidpos, [1 ndim], 'single');
    if showFeat
        feat = reshape(data, height, width, nchannel);
        figure(2);
        for nd = 1 : nchannel
            figure(2), subplot(1, nchannel, nd), imagesc(feat(:,:, nd)), colormap(gray), axis image, axis on;
        end
        
    end
    pause;
end
fclose(fidpos);