function featLSK = computeLSK(im, conf)
%% LSK features in C

% patch size for averaging covariance matrix = wsize (should be odd)
% #LSK channels: #neighborhood size (can be odd/even) = nbors
% kernel parameter (whole denomiator, with 2 aborbed) = h (keep at 2)
% smoothing parameter alpha = alp

% Implemented by Sujoy Biswas (June 1st, 2016)

[zx,zy]=gradient(im);

wsize = conf.Wsize;
win = (wsize-1)/2;
K = fspecial('disk', win);
K = K ./ K(win+1, win+1);
len = sum(K(:));

nbors = conf.nbors; 
h = conf.h; 
alp = conf.alpha;  

featLSK =  getlsk(zx, zy, K, len, wsize, nbors, h, alp);

end

